"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var server_1 = __importDefault(require("react-dom/server"));
// @ts-ignore
var server_express_1 = require("@react-fullstack/server-express");
var express_1 = __importDefault(require("express"));
var ReactRoute = /** @class */ (function (_super) {
    __extends(ReactRoute, _super);
    function ReactRoute() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getApp = function (req, res, next) {
            var reactNodes;
            if (typeof _this.props.children === "function") {
                reactNodes = _this.props.children(req, res, next);
            }
            else {
                reactNodes = _this.props.children;
            }
            res.send(server_1.default.renderToString(react_1.default.createElement(react_1.default.Fragment, null, reactNodes)));
        };
        return _this;
    }
    ReactRoute.prototype.render = function () {
        return (react_1.default.createElement(server_express_1.Router, { path: this.props.rootPath || "/" },
            this.props.assetsDir && (react_1.default.createElement(server_express_1.Middleware, { middlewares: [express_1.default.static(this.props.assetsDir, { index: "/" })] })),
            react_1.default.createElement(server_express_1.Route, { path: this.props.indexPath || "/", get: this.getApp })));
    };
    return ReactRoute;
}(react_1.default.Component));
exports.default = ReactRoute;
